/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by informer-gen. DO NOT EDIT.

package externalversions

import (
	"fmt"

	v1alpha6 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1alpha6"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	cache "k8s.io/client-go/tools/cache"
)

// GenericInformer is type of SharedIndexInformer which will locate and delegate to other
// sharedInformers based on type
type GenericInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() cache.GenericLister
}

type genericInformer struct {
	informer cache.SharedIndexInformer
	resource schema.GroupResource
}

// Informer returns the SharedIndexInformer.
func (f *genericInformer) Informer() cache.SharedIndexInformer {
	return f.informer
}

// Lister returns the GenericLister.
func (f *genericInformer) Lister() cache.GenericLister {
	return cache.NewGenericLister(f.Informer().GetIndexer(), f.resource)
}

// ForResource gives generic access to a shared informer of the matching type
// TODO extend this to unknown resources with a client pool
func (f *sharedInformerFactory) ForResource(resource schema.GroupVersionResource) (GenericInformer, error) {
	switch resource {
	// Group=infrastructure.cluster.x-k8s.io, Version=v1alpha6
	case v1alpha6.SchemeGroupVersion.WithResource("openstackclusters"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Infrastructure().V1alpha6().OpenStackClusters().Informer()}, nil
	case v1alpha6.SchemeGroupVersion.WithResource("openstackclustertemplates"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Infrastructure().V1alpha6().OpenStackClusterTemplates().Informer()}, nil
	case v1alpha6.SchemeGroupVersion.WithResource("openstackmachines"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Infrastructure().V1alpha6().OpenStackMachines().Informer()}, nil
	case v1alpha6.SchemeGroupVersion.WithResource("openstackmachinetemplates"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Infrastructure().V1alpha6().OpenStackMachineTemplates().Informer()}, nil

	}

	return nil, fmt.Errorf("no informer found for %v", resource)
}
